/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* RISCVPostLegalizerCombinerImpl Combiner Match Table                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct RISCVPostLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 10:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 10;	 // "i2p_to_p2i"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 9;	 // "p2i_to_i2p"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_to_add", 9) != 0)
        break;
      return 0;	 // "sub_to_add"
    }
    break;
  case 11:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "add_sub_reg", 11) != 0)
      break;
    return 15;	 // "add_sub_reg"
  case 13:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 2;	 // "load_and_mask"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 3;	 // "redundant_and"
    }
    break;
  case 14:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_same_val", 13) != 0)
        break;
      return 6;	 // "binop_same_val"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_fneg_fold", 13) != 0)
        break;
      return 12;	 // "fneg_fneg_fold"
    }
    break;
  case 15:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 1;	 // "extending_loads"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 4;	 // "select_same_val"
    }
    break;
  case 17:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_trunc_fold", 16) != 0)
        break;
      return 11;	 // "anyext_trunc_fold"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_immed_chain", 16) != 0)
        break;
      return 23;	 // "shift_immed_chain"
    }
    break;
  case 18:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 7;	 // "binop_left_to_zero"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ptrunc_fpext_fold", 17) != 0)
        break;
      return 20;	 // "fptrunc_fpext_fold"
    }
    break;
  case 19:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 8;	 // "binop_right_to_zero"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_zero", 18) != 0)
        break;
      return 5;	 // "right_identity_zero"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "implify_neg_minmax", 18) != 0)
        break;
      return 26;	 // "simplify_neg_minmax"
    }
    break;
  case 20:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "bitcast_bitcast_fold", 20) != 0)
      break;
    return 19;	 // "bitcast_bitcast_fold"
  case 21:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "right_identity_one_fp", 21) != 0)
      break;
    return 14;	 // "right_identity_one_fp"
  case 22:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_int", 21) != 0)
        break;
      return 13;	 // "right_identity_one_int"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 17;	 // "trunc_buildvector_fold"
    }
    break;
  case 25:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_identity_fold", 24) != 0)
        break;
      return 16;	 // "buildvector_identity_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 22;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 25;	 // "commute_fp_constant_to_rhs"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 21;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_int_constant_to_rhs", 26) != 0)
        break;
      return 24;	 // "commute_int_constant_to_rhs"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 18;	 // "trunc_lshr_buildvector_fold"
    }
    break;
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 27}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool RISCVPostLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool RISCVPostLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> RISCVPostLegalizerCombinerOption;
static cl::list<std::string> RISCVPostLegalizerCombinerDisableOption(
    "riscvpostlegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the RISCVPostLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      RISCVPostLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> RISCVPostLegalizerCombinerOnlyEnableOption(
    "riscvpostlegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the RISCVPostLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      RISCVPostLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        RISCVPostLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool RISCVPostLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool RISCVPostLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : RISCVPostLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 0;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(RISCVPostLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(RISCVPostLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static RISCVPostLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static RISCVPostLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
};

PredicateBitset RISCVPostLegalizerCombinerImpl::
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const {
  PredicateBitset Features{};
  return Features;
}

void RISCVPostLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const RISCVSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset RISCVPostLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

RISCVPostLegalizerCombinerImpl::ComplexMatcherMemFn
RISCVPostLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
};
bool RISCVPostLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPostLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPostLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPostLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
};

bool RISCVPostLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
RISCVPostLegalizerCombinerImpl::CustomRendererFn
RISCVPostLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool RISCVPostLegalizerCombinerImpl::tryCombineAll(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
};
bool RISCVPostLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *RISCVPostLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(228), /*)*//*default:*//*Label 55*/ GIMT_Encode4(1930),
     /*   10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(710),
     /*   14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(813),
     /*   18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(869),
     /*   22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(927),
     /*   26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(939),
     /*   30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(951),
     /*   34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(963), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(975),
     /*   50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(1033),
     /*   54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(1092), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  106 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 10*/ GIMT_Encode4(1127),
     /*  110 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 11*/ GIMT_Encode4(1139), GIMT_Encode4(0),
     /*  118 */ /*TargetOpcode::G_PTRTOINT*//*Label 12*/ GIMT_Encode4(1151),
     /*  122 */ /*TargetOpcode::G_INTTOPTR*//*Label 13*/ GIMT_Encode4(1173),
     /*  126 */ /*TargetOpcode::G_BITCAST*//*Label 14*/ GIMT_Encode4(1185), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  170 */ /*TargetOpcode::G_LOAD*//*Label 15*/ GIMT_Encode4(1207),
     /*  174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 16*/ GIMT_Encode4(1219),
     /*  178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 17*/ GIMT_Encode4(1231), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  330 */ /*TargetOpcode::G_ANYEXT*//*Label 18*/ GIMT_Encode4(1243),
     /*  334 */ /*TargetOpcode::G_TRUNC*//*Label 19*/ GIMT_Encode4(1255), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  366 */ /*TargetOpcode::G_SHL*//*Label 20*/ GIMT_Encode4(1278),
     /*  370 */ /*TargetOpcode::G_LSHR*//*Label 21*/ GIMT_Encode4(1324),
     /*  374 */ /*TargetOpcode::G_ASHR*//*Label 22*/ GIMT_Encode4(1370), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  386 */ /*TargetOpcode::G_ROTR*//*Label 23*/ GIMT_Encode4(1416),
     /*  390 */ /*TargetOpcode::G_ROTL*//*Label 24*/ GIMT_Encode4(1440), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  410 */ /*TargetOpcode::G_SELECT*//*Label 25*/ GIMT_Encode4(1464),
     /*  414 */ /*TargetOpcode::G_UADDO*//*Label 26*/ GIMT_Encode4(1476), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  430 */ /*TargetOpcode::G_SADDO*//*Label 27*/ GIMT_Encode4(1488), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  446 */ /*TargetOpcode::G_UMULO*//*Label 28*/ GIMT_Encode4(1500),
     /*  450 */ /*TargetOpcode::G_SMULO*//*Label 29*/ GIMT_Encode4(1512),
     /*  454 */ /*TargetOpcode::G_UMULH*//*Label 30*/ GIMT_Encode4(1524),
     /*  458 */ /*TargetOpcode::G_SMULH*//*Label 31*/ GIMT_Encode4(1536),
     /*  462 */ /*TargetOpcode::G_UADDSAT*//*Label 32*/ GIMT_Encode4(1548),
     /*  466 */ /*TargetOpcode::G_SADDSAT*//*Label 33*/ GIMT_Encode4(1560), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  478 */ /*TargetOpcode::G_USHLSAT*//*Label 34*/ GIMT_Encode4(1572),
     /*  482 */ /*TargetOpcode::G_SSHLSAT*//*Label 35*/ GIMT_Encode4(1584),
     /*  486 */ /*TargetOpcode::G_SMULFIX*//*Label 36*/ GIMT_Encode4(1596),
     /*  490 */ /*TargetOpcode::G_UMULFIX*//*Label 37*/ GIMT_Encode4(1608),
     /*  494 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 38*/ GIMT_Encode4(1620),
     /*  498 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 39*/ GIMT_Encode4(1632), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  518 */ /*TargetOpcode::G_FADD*//*Label 40*/ GIMT_Encode4(1644), GIMT_Encode4(0),
     /*  526 */ /*TargetOpcode::G_FMUL*//*Label 41*/ GIMT_Encode4(1679), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  586 */ /*TargetOpcode::G_FNEG*//*Label 42*/ GIMT_Encode4(1734), GIMT_Encode4(0),
     /*  594 */ /*TargetOpcode::G_FPTRUNC*//*Label 43*/ GIMT_Encode4(1764), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  638 */ /*TargetOpcode::G_FMINNUM*//*Label 44*/ GIMT_Encode4(1786),
     /*  642 */ /*TargetOpcode::G_FMAXNUM*//*Label 45*/ GIMT_Encode4(1798),
     /*  646 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 46*/ GIMT_Encode4(1810),
     /*  650 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 47*/ GIMT_Encode4(1822),
     /*  654 */ /*TargetOpcode::G_FMINIMUM*//*Label 48*/ GIMT_Encode4(1834),
     /*  658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 49*/ GIMT_Encode4(1846), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  686 */ /*TargetOpcode::G_PTR_ADD*//*Label 50*/ GIMT_Encode4(1858), GIMT_Encode4(0),
     /*  694 */ /*TargetOpcode::G_SMIN*//*Label 51*/ GIMT_Encode4(1882),
     /*  698 */ /*TargetOpcode::G_SMAX*//*Label 52*/ GIMT_Encode4(1894),
     /*  702 */ /*TargetOpcode::G_UMIN*//*Label 53*/ GIMT_Encode4(1906),
     /*  706 */ /*TargetOpcode::G_UMAX*//*Label 54*/ GIMT_Encode4(1918),
     /*  710 */ // Label 0: @710
     /*  710 */ GIM_Try, /*On fail goto*//*Label 56*/ GIMT_Encode4(721), // Rule ID 48 //
     /*  715 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /*  718 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /*  718 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /*  721 */ // Label 56: @721
     /*  721 */ GIM_Try, /*On fail goto*//*Label 57*/ GIMT_Encode4(755), // Rule ID 34 //
     /*  726 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /*  729 */   // MIs[0] dst
     /*  729 */   // No operand predicates
     /*  729 */   // MIs[0] __add_sub_reg_match_0.tmp
     /*  729 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  733 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  737 */   // MIs[1] src
     /*  737 */   // No operand predicates
     /*  737 */   // MIs[1] __add_sub_reg_match_0.x
     /*  737 */   // No operand predicates
     /*  737 */   // MIs[0] __add_sub_reg_match_0.x
     /*  737 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  742 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  747 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  749 */   // Combiner Rule #15: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /*  749 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  754 */   GIR_EraseRootFromParent_Done,
     /*  755 */ // Label 57: @755
     /*  755 */ GIM_Try, /*On fail goto*//*Label 58*/ GIMT_Encode4(789), // Rule ID 33 //
     /*  760 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /*  763 */   // MIs[0] dst
     /*  763 */   // No operand predicates
     /*  763 */   // MIs[0] __add_sub_reg_match_0.x
     /*  763 */   // No operand predicates
     /*  763 */   // MIs[0] __add_sub_reg_match_0.tmp
     /*  763 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  767 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  771 */   // MIs[1] src
     /*  771 */   // No operand predicates
     /*  771 */   // MIs[1] __add_sub_reg_match_0.x
     /*  771 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  776 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  781 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  783 */   // Combiner Rule #15: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /*  783 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  788 */   GIR_EraseRootFromParent_Done,
     /*  789 */ // Label 58: @789
     /*  789 */ GIM_Try, /*On fail goto*//*Label 59*/ GIMT_Encode4(812), // Rule ID 8 //
     /*  794 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /*  797 */   // MIs[0] dst
     /*  797 */   // No operand predicates
     /*  797 */   // MIs[0] lhs
     /*  797 */   // No operand predicates
     /*  797 */   // MIs[0] Operand 2
     /*  797 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  801 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  806 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /*  806 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  811 */   GIR_EraseRootFromParent_Done,
     /*  812 */ // Label 59: @812
     /*  812 */ GIM_Reject,
     /*  813 */ // Label 1: @813
     /*  813 */ GIM_Try, /*On fail goto*//*Label 60*/ GIMT_Encode4(824), // Rule ID 77 //
     /*  818 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /*  821 */   // Combiner Rule #26: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /*  821 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /*  824 */ // Label 60: @824
     /*  824 */ GIM_Try, /*On fail goto*//*Label 61*/ GIMT_Encode4(847), // Rule ID 7 //
     /*  829 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /*  832 */   // MIs[0] dst
     /*  832 */   // No operand predicates
     /*  832 */   // MIs[0] lhs
     /*  832 */   // No operand predicates
     /*  832 */   // MIs[0] Operand 2
     /*  832 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  836 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  841 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /*  841 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  846 */   GIR_EraseRootFromParent_Done,
     /*  847 */ // Label 61: @847
     /*  847 */ GIM_Try, /*On fail goto*//*Label 62*/ GIMT_Encode4(868), // Rule ID 0 //
     /*  852 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /*  855 */   // MIs[0] d
     /*  855 */   // No operand predicates
     /*  855 */   // MIs[0] op1
     /*  855 */   // No operand predicates
     /*  855 */   // MIs[0] c
     /*  855 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  859 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  863 */   // MIs[1] imm
     /*  863 */   // No operand predicates
     /*  863 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  865 */   // Combiner Rule #0: sub_to_add
     /*  865 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /*  868 */ // Label 62: @868
     /*  868 */ GIM_Reject,
     /*  869 */ // Label 2: @869
     /*  869 */ GIM_Try, /*On fail goto*//*Label 63*/ GIMT_Encode4(880), // Rule ID 49 //
     /*  874 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /*  877 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /*  877 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /*  880 */ // Label 63: @880
     /*  880 */ GIM_Try, /*On fail goto*//*Label 64*/ GIMT_Encode4(903), // Rule ID 26 //
     /*  885 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /*  888 */   // MIs[0] dst
     /*  888 */   // No operand predicates
     /*  888 */   // MIs[0] lhs
     /*  888 */   // No operand predicates
     /*  888 */   // MIs[0] zero
     /*  888 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  892 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /*  897 */   // Combiner Rule #8: binop_right_to_zero
     /*  897 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /*  902 */   GIR_EraseRootFromParent_Done,
     /*  903 */ // Label 64: @903
     /*  903 */ GIM_Try, /*On fail goto*//*Label 65*/ GIMT_Encode4(926), // Rule ID 31 //
     /*  908 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /*  911 */   // MIs[0] dst
     /*  911 */   // No operand predicates
     /*  911 */   // MIs[0] x
     /*  911 */   // No operand predicates
     /*  911 */   // MIs[0] Operand 2
     /*  911 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  915 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  920 */   // Combiner Rule #13: right_identity_one_int
     /*  920 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  925 */   GIR_EraseRootFromParent_Done,
     /*  926 */ // Label 65: @926
     /*  926 */ GIM_Reject,
     /*  927 */ // Label 3: @927
     /*  927 */ GIM_Try, /*On fail goto*//*Label 66*/ GIMT_Encode4(938), // Rule ID 22 //
     /*  932 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /*  935 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /*  935 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  938 */ // Label 66: @938
     /*  938 */ GIM_Reject,
     /*  939 */ // Label 4: @939
     /*  939 */ GIM_Try, /*On fail goto*//*Label 67*/ GIMT_Encode4(950), // Rule ID 23 //
     /*  944 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /*  947 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /*  947 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  950 */ // Label 67: @950
     /*  950 */ GIM_Reject,
     /*  951 */ // Label 5: @951
     /*  951 */ GIM_Try, /*On fail goto*//*Label 68*/ GIMT_Encode4(962), // Rule ID 24 //
     /*  956 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /*  959 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /*  959 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  962 */ // Label 68: @962
     /*  962 */ GIM_Reject,
     /*  963 */ // Label 6: @963
     /*  963 */ GIM_Try, /*On fail goto*//*Label 69*/ GIMT_Encode4(974), // Rule ID 25 //
     /*  968 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /*  971 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /*  971 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  974 */ // Label 69: @974
     /*  974 */ GIM_Reject,
     /*  975 */ // Label 7: @975
     /*  975 */ GIM_Try, /*On fail goto*//*Label 70*/ GIMT_Encode4(986), // Rule ID 4 //
     /*  980 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /*  983 */   // Combiner Rule #2: load_and_mask; wip_match_opcode 'G_AND'
     /*  983 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /*  986 */ // Label 70: @986
     /*  986 */ GIM_Try, /*On fail goto*//*Label 71*/ GIMT_Encode4(997), // Rule ID 5 //
     /*  991 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /*  994 */   // Combiner Rule #3: redundant_and; wip_match_opcode 'G_AND'
     /*  994 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /*  997 */ // Label 71: @997
     /*  997 */ GIM_Try, /*On fail goto*//*Label 72*/ GIMT_Encode4(1008), // Rule ID 50 //
     /* 1002 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1005 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 1005 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1008 */ // Label 72: @1008
     /* 1008 */ GIM_Try, /*On fail goto*//*Label 73*/ GIMT_Encode4(1032), // Rule ID 17 //
     /* 1013 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1016 */   // MIs[0] dst
     /* 1016 */   // No operand predicates
     /* 1016 */   // MIs[0] src
     /* 1016 */   // No operand predicates
     /* 1016 */   // MIs[0] src
     /* 1016 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1021 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1026 */   // Combiner Rule #6: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 1026 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1031 */   GIR_EraseRootFromParent_Done,
     /* 1032 */ // Label 73: @1032
     /* 1032 */ GIM_Reject,
     /* 1033 */ // Label 8: @1033
     /* 1033 */ GIM_Try, /*On fail goto*//*Label 74*/ GIMT_Encode4(1044), // Rule ID 51 //
     /* 1038 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1041 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 1041 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1044 */ // Label 74: @1044
     /* 1044 */ GIM_Try, /*On fail goto*//*Label 75*/ GIMT_Encode4(1068), // Rule ID 18 //
     /* 1049 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1052 */   // MIs[0] dst
     /* 1052 */   // No operand predicates
     /* 1052 */   // MIs[0] src
     /* 1052 */   // No operand predicates
     /* 1052 */   // MIs[0] src
     /* 1052 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1057 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1062 */   // Combiner Rule #6: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 1062 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1067 */   GIR_EraseRootFromParent_Done,
     /* 1068 */ // Label 75: @1068
     /* 1068 */ GIM_Try, /*On fail goto*//*Label 76*/ GIMT_Encode4(1091), // Rule ID 9 //
     /* 1073 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1076 */   // MIs[0] dst
     /* 1076 */   // No operand predicates
     /* 1076 */   // MIs[0] lhs
     /* 1076 */   // No operand predicates
     /* 1076 */   // MIs[0] Operand 2
     /* 1076 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1080 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1085 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 1085 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1090 */   GIR_EraseRootFromParent_Done,
     /* 1091 */ // Label 76: @1091
     /* 1091 */ GIM_Reject,
     /* 1092 */ // Label 9: @1092
     /* 1092 */ GIM_Try, /*On fail goto*//*Label 77*/ GIMT_Encode4(1103), // Rule ID 52 //
     /* 1097 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1100 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 1100 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1103 */ // Label 77: @1103
     /* 1103 */ GIM_Try, /*On fail goto*//*Label 78*/ GIMT_Encode4(1126), // Rule ID 10 //
     /* 1108 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1111 */   // MIs[0] dst
     /* 1111 */   // No operand predicates
     /* 1111 */   // MIs[0] lhs
     /* 1111 */   // No operand predicates
     /* 1111 */   // MIs[0] Operand 2
     /* 1111 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1115 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1120 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 1120 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1125 */   GIR_EraseRootFromParent_Done,
     /* 1126 */ // Label 78: @1126
     /* 1126 */ GIM_Reject,
     /* 1127 */ // Label 10: @1127
     /* 1127 */ GIM_Try, /*On fail goto*//*Label 79*/ GIMT_Encode4(1138), // Rule ID 36 //
     /* 1132 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1135 */   // Combiner Rule #16: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 1135 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 1138 */ // Label 79: @1138
     /* 1138 */ GIM_Reject,
     /* 1139 */ // Label 11: @1139
     /* 1139 */ GIM_Try, /*On fail goto*//*Label 80*/ GIMT_Encode4(1150), // Rule ID 35 //
     /* 1144 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1147 */   // Combiner Rule #16: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 1147 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 1150 */ // Label 80: @1150
     /* 1150 */ GIM_Reject,
     /* 1151 */ // Label 12: @1151
     /* 1151 */ GIM_Try, /*On fail goto*//*Label 81*/ GIMT_Encode4(1172), // Rule ID 28 //
     /* 1156 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 1159 */   // MIs[0] dst
     /* 1159 */   // No operand predicates
     /* 1159 */   // MIs[0] t
     /* 1159 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1163 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 1167 */   // MIs[1] ptr
     /* 1167 */   // No operand predicates
     /* 1167 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1169 */   // Combiner Rule #10: i2p_to_p2i
     /* 1169 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 1172 */ // Label 81: @1172
     /* 1172 */ GIM_Reject,
     /* 1173 */ // Label 13: @1173
     /* 1173 */ GIM_Try, /*On fail goto*//*Label 82*/ GIMT_Encode4(1184), // Rule ID 27 //
     /* 1178 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 1181 */   // Combiner Rule #9: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 1181 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 1184 */ // Label 82: @1184
     /* 1184 */ GIM_Reject,
     /* 1185 */ // Label 14: @1185
     /* 1185 */ GIM_Try, /*On fail goto*//*Label 83*/ GIMT_Encode4(1206), // Rule ID 39 //
     /* 1190 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 1193 */   // MIs[0] dst
     /* 1193 */   // No operand predicates
     /* 1193 */   // MIs[0] src1
     /* 1193 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1197 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 1201 */   // MIs[1] src0
     /* 1201 */   // No operand predicates
     /* 1201 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1203 */   // Combiner Rule #19: bitcast_bitcast_fold
     /* 1203 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 1206 */ // Label 83: @1206
     /* 1206 */ GIM_Reject,
     /* 1207 */ // Label 15: @1207
     /* 1207 */ GIM_Try, /*On fail goto*//*Label 84*/ GIMT_Encode4(1218), // Rule ID 1 //
     /* 1212 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1215 */   // Combiner Rule #1: extending_loads; wip_match_opcode 'G_LOAD'
     /* 1215 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1218 */ // Label 84: @1218
     /* 1218 */ GIM_Reject,
     /* 1219 */ // Label 16: @1219
     /* 1219 */ GIM_Try, /*On fail goto*//*Label 85*/ GIMT_Encode4(1230), // Rule ID 2 //
     /* 1224 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1227 */   // Combiner Rule #1: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 1227 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1230 */ // Label 85: @1230
     /* 1230 */ GIM_Reject,
     /* 1231 */ // Label 17: @1231
     /* 1231 */ GIM_Try, /*On fail goto*//*Label 86*/ GIMT_Encode4(1242), // Rule ID 3 //
     /* 1236 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1239 */   // Combiner Rule #1: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 1239 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1242 */ // Label 86: @1242
     /* 1242 */ GIM_Reject,
     /* 1243 */ // Label 18: @1243
     /* 1243 */ GIM_Try, /*On fail goto*//*Label 87*/ GIMT_Encode4(1254), // Rule ID 29 //
     /* 1248 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 1251 */   // Combiner Rule #11: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 1251 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 1254 */ // Label 87: @1254
     /* 1254 */ GIM_Reject,
     /* 1255 */ // Label 19: @1255
     /* 1255 */ GIM_Try, /*On fail goto*//*Label 88*/ GIMT_Encode4(1266), // Rule ID 37 //
     /* 1260 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 1263 */   // Combiner Rule #17: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 1263 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 1266 */ // Label 88: @1266
     /* 1266 */ GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(1277), // Rule ID 38 //
     /* 1271 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 1274 */   // Combiner Rule #18: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 1274 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 1277 */ // Label 89: @1277
     /* 1277 */ GIM_Reject,
     /* 1278 */ // Label 20: @1278
     /* 1278 */ GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1289), // Rule ID 19 //
     /* 1283 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1286 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 1286 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1289 */ // Label 90: @1289
     /* 1289 */ GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1300), // Rule ID 43 //
     /* 1294 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1297 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 1297 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1300 */ // Label 91: @1300
     /* 1300 */ GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1323), // Rule ID 11 //
     /* 1305 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1308 */   // MIs[0] dst
     /* 1308 */   // No operand predicates
     /* 1308 */   // MIs[0] lhs
     /* 1308 */   // No operand predicates
     /* 1308 */   // MIs[0] Operand 2
     /* 1308 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1312 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1317 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 1317 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1322 */   GIR_EraseRootFromParent_Done,
     /* 1323 */ // Label 92: @1323
     /* 1323 */ GIM_Reject,
     /* 1324 */ // Label 21: @1324
     /* 1324 */ GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1335), // Rule ID 20 //
     /* 1329 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1332 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 1332 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1335 */ // Label 93: @1335
     /* 1335 */ GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1346), // Rule ID 45 //
     /* 1340 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1343 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 1343 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1346 */ // Label 94: @1346
     /* 1346 */ GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1369), // Rule ID 13 //
     /* 1351 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1354 */   // MIs[0] dst
     /* 1354 */   // No operand predicates
     /* 1354 */   // MIs[0] lhs
     /* 1354 */   // No operand predicates
     /* 1354 */   // MIs[0] Operand 2
     /* 1354 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1358 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1363 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 1363 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1368 */   GIR_EraseRootFromParent_Done,
     /* 1369 */ // Label 95: @1369
     /* 1369 */ GIM_Reject,
     /* 1370 */ // Label 22: @1370
     /* 1370 */ GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1381), // Rule ID 21 //
     /* 1375 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1378 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 1378 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1381 */ // Label 96: @1381
     /* 1381 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1392), // Rule ID 44 //
     /* 1386 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1389 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 1389 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1392 */ // Label 97: @1392
     /* 1392 */ GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1415), // Rule ID 12 //
     /* 1397 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1400 */   // MIs[0] dst
     /* 1400 */   // No operand predicates
     /* 1400 */   // MIs[0] lhs
     /* 1400 */   // No operand predicates
     /* 1400 */   // MIs[0] Operand 2
     /* 1400 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1404 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1409 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 1409 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1414 */   GIR_EraseRootFromParent_Done,
     /* 1415 */ // Label 98: @1415
     /* 1415 */ GIM_Reject,
     /* 1416 */ // Label 23: @1416
     /* 1416 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1439), // Rule ID 16 //
     /* 1421 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1424 */   // MIs[0] dst
     /* 1424 */   // No operand predicates
     /* 1424 */   // MIs[0] lhs
     /* 1424 */   // No operand predicates
     /* 1424 */   // MIs[0] Operand 2
     /* 1424 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1428 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1433 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 1433 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1438 */   GIR_EraseRootFromParent_Done,
     /* 1439 */ // Label 99: @1439
     /* 1439 */ GIM_Reject,
     /* 1440 */ // Label 24: @1440
     /* 1440 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1463), // Rule ID 15 //
     /* 1445 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1448 */   // MIs[0] dst
     /* 1448 */   // No operand predicates
     /* 1448 */   // MIs[0] lhs
     /* 1448 */   // No operand predicates
     /* 1448 */   // MIs[0] Operand 2
     /* 1448 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1452 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1457 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 1457 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1462 */   GIR_EraseRootFromParent_Done,
     /* 1463 */ // Label 100: @1463
     /* 1463 */ GIM_Reject,
     /* 1464 */ // Label 25: @1464
     /* 1464 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1475), // Rule ID 6 //
     /* 1469 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 1472 */   // Combiner Rule #4: select_same_val; wip_match_opcode 'G_SELECT'
     /* 1472 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 1475 */ // Label 101: @1475
     /* 1475 */ GIM_Reject,
     /* 1476 */ // Label 26: @1476
     /* 1476 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1487), // Rule ID 57 //
     /* 1481 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1484 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 1484 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1487 */ // Label 102: @1487
     /* 1487 */ GIM_Reject,
     /* 1488 */ // Label 27: @1488
     /* 1488 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1499), // Rule ID 58 //
     /* 1493 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1496 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 1496 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1499 */ // Label 103: @1499
     /* 1499 */ GIM_Reject,
     /* 1500 */ // Label 28: @1500
     /* 1500 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1511), // Rule ID 59 //
     /* 1505 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1508 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 1508 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1511 */ // Label 104: @1511
     /* 1511 */ GIM_Reject,
     /* 1512 */ // Label 29: @1512
     /* 1512 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1523), // Rule ID 60 //
     /* 1517 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1520 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 1520 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1523 */ // Label 105: @1523
     /* 1523 */ GIM_Reject,
     /* 1524 */ // Label 30: @1524
     /* 1524 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1535), // Rule ID 61 //
     /* 1529 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1532 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 1532 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1535 */ // Label 106: @1535
     /* 1535 */ GIM_Reject,
     /* 1536 */ // Label 31: @1536
     /* 1536 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1547), // Rule ID 62 //
     /* 1541 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1544 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 1544 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1547 */ // Label 107: @1547
     /* 1547 */ GIM_Reject,
     /* 1548 */ // Label 32: @1548
     /* 1548 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1559), // Rule ID 63 //
     /* 1553 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1556 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 1556 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1559 */ // Label 108: @1559
     /* 1559 */ GIM_Reject,
     /* 1560 */ // Label 33: @1560
     /* 1560 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1571), // Rule ID 64 //
     /* 1565 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1568 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 1568 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1571 */ // Label 109: @1571
     /* 1571 */ GIM_Reject,
     /* 1572 */ // Label 34: @1572
     /* 1572 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1583), // Rule ID 47 //
     /* 1577 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1580 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 1580 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1583 */ // Label 110: @1583
     /* 1583 */ GIM_Reject,
     /* 1584 */ // Label 35: @1584
     /* 1584 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1595), // Rule ID 46 //
     /* 1589 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1592 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 1592 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1595 */ // Label 111: @1595
     /* 1595 */ GIM_Reject,
     /* 1596 */ // Label 36: @1596
     /* 1596 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1607), // Rule ID 65 //
     /* 1601 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1604 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 1604 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1607 */ // Label 112: @1607
     /* 1607 */ GIM_Reject,
     /* 1608 */ // Label 37: @1608
     /* 1608 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1619), // Rule ID 66 //
     /* 1613 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1616 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 1616 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1619 */ // Label 113: @1619
     /* 1619 */ GIM_Reject,
     /* 1620 */ // Label 38: @1620
     /* 1620 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1631), // Rule ID 67 //
     /* 1625 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1628 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 1628 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1631 */ // Label 114: @1631
     /* 1631 */ GIM_Reject,
     /* 1632 */ // Label 39: @1632
     /* 1632 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1643), // Rule ID 68 //
     /* 1637 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1640 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 1640 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1643 */ // Label 115: @1643
     /* 1643 */ GIM_Reject,
     /* 1644 */ // Label 40: @1644
     /* 1644 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1655), // Rule ID 69 //
     /* 1649 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1652 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 1652 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1655 */ // Label 116: @1655
     /* 1655 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1678), // Rule ID 41 //
     /* 1660 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 1663 */   // MIs[0] dst
     /* 1663 */   // No operand predicates
     /* 1663 */   // MIs[0] x
     /* 1663 */   // No operand predicates
     /* 1663 */   // MIs[0] y
     /* 1663 */   // No operand predicates
     /* 1663 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 1667 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1672 */   // Combiner Rule #21: right_identity_neg_zero_fp
     /* 1672 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1677 */   GIR_EraseRootFromParent_Done,
     /* 1678 */ // Label 117: @1678
     /* 1678 */ GIM_Reject,
     /* 1679 */ // Label 41: @1679
     /* 1679 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1690), // Rule ID 70 //
     /* 1684 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1687 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 1687 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1690 */ // Label 118: @1690
     /* 1690 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1713), // Rule ID 32 //
     /* 1695 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 1698 */   // MIs[0] dst
     /* 1698 */   // No operand predicates
     /* 1698 */   // MIs[0] x
     /* 1698 */   // No operand predicates
     /* 1698 */   // MIs[0] y
     /* 1698 */   // No operand predicates
     /* 1698 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 1702 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1707 */   // Combiner Rule #14: right_identity_one_fp
     /* 1707 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1712 */   GIR_EraseRootFromParent_Done,
     /* 1713 */ // Label 119: @1713
     /* 1713 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1733), // Rule ID 42 //
     /* 1718 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 1721 */   // MIs[0] dst
     /* 1721 */   // No operand predicates
     /* 1721 */   // MIs[0] x
     /* 1721 */   // No operand predicates
     /* 1721 */   // MIs[0] y
     /* 1721 */   // No operand predicates
     /* 1721 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 1725 */   // Combiner Rule #22: right_identity_neg_one_fp
     /* 1725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 1728 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 1730 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 1732 */   GIR_EraseRootFromParent_Done,
     /* 1733 */ // Label 120: @1733
     /* 1733 */ GIM_Reject,
     /* 1734 */ // Label 42: @1734
     /* 1734 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1763), // Rule ID 30 //
     /* 1739 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 1742 */   // MIs[0] dst
     /* 1742 */   // No operand predicates
     /* 1742 */   // MIs[0] t
     /* 1742 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1746 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 1750 */   // MIs[1] src
     /* 1750 */   // No operand predicates
     /* 1750 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1755 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1757 */   // Combiner Rule #12: fneg_fneg_fold
     /* 1757 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1762 */   GIR_EraseRootFromParent_Done,
     /* 1763 */ // Label 121: @1763
     /* 1763 */ GIM_Reject,
     /* 1764 */ // Label 43: @1764
     /* 1764 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1785), // Rule ID 40 //
     /* 1769 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 1772 */   // MIs[0] dst
     /* 1772 */   // No operand predicates
     /* 1772 */   // MIs[0] src1
     /* 1772 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1776 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 1780 */   // MIs[1] src0
     /* 1780 */   // No operand predicates
     /* 1780 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1782 */   // Combiner Rule #20: fptrunc_fpext_fold
     /* 1782 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 1785 */ // Label 122: @1785
     /* 1785 */ GIM_Reject,
     /* 1786 */ // Label 44: @1786
     /* 1786 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1797), // Rule ID 71 //
     /* 1791 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1794 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 1794 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1797 */ // Label 123: @1797
     /* 1797 */ GIM_Reject,
     /* 1798 */ // Label 45: @1798
     /* 1798 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1809), // Rule ID 72 //
     /* 1803 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1806 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 1806 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1809 */ // Label 124: @1809
     /* 1809 */ GIM_Reject,
     /* 1810 */ // Label 46: @1810
     /* 1810 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1821), // Rule ID 73 //
     /* 1815 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1818 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 1818 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1821 */ // Label 125: @1821
     /* 1821 */ GIM_Reject,
     /* 1822 */ // Label 47: @1822
     /* 1822 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1833), // Rule ID 74 //
     /* 1827 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1830 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 1830 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1833 */ // Label 126: @1833
     /* 1833 */ GIM_Reject,
     /* 1834 */ // Label 48: @1834
     /* 1834 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1845), // Rule ID 75 //
     /* 1839 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1842 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 1842 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1845 */ // Label 127: @1845
     /* 1845 */ GIM_Reject,
     /* 1846 */ // Label 49: @1846
     /* 1846 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1857), // Rule ID 76 //
     /* 1851 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1854 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 1854 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1857 */ // Label 128: @1857
     /* 1857 */ GIM_Reject,
     /* 1858 */ // Label 50: @1858
     /* 1858 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1881), // Rule ID 14 //
     /* 1863 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1866 */   // MIs[0] dst
     /* 1866 */   // No operand predicates
     /* 1866 */   // MIs[0] lhs
     /* 1866 */   // No operand predicates
     /* 1866 */   // MIs[0] Operand 2
     /* 1866 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1870 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1875 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 1875 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1880 */   GIR_EraseRootFromParent_Done,
     /* 1881 */ // Label 129: @1881
     /* 1881 */ GIM_Reject,
     /* 1882 */ // Label 51: @1882
     /* 1882 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1893), // Rule ID 53 //
     /* 1887 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1890 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 1890 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1893 */ // Label 130: @1893
     /* 1893 */ GIM_Reject,
     /* 1894 */ // Label 52: @1894
     /* 1894 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1905), // Rule ID 54 //
     /* 1899 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1902 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 1902 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1905 */ // Label 131: @1905
     /* 1905 */ GIM_Reject,
     /* 1906 */ // Label 53: @1906
     /* 1906 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1917), // Rule ID 55 //
     /* 1911 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1914 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 1914 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1917 */ // Label 132: @1917
     /* 1917 */ GIM_Reject,
     /* 1918 */ // Label 54: @1918
     /* 1918 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1929), // Rule ID 56 //
     /* 1923 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1926 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 1926 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1929 */ // Label 133: @1929
     /* 1929 */ GIM_Reject,
     /* 1930 */ // Label 55: @1930
     /* 1930 */ GIM_Reject,
     /* 1931 */ }; // Size: 1931 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

